<?php
	include( 'helper.inc.php' );
	include( 'phpSerial.inc.php' );

	set_error_handler( errorHandlerAJAX, E_ALL );

	$sendMessage = sanitize( isset( $_POST['sendmessage'] ) ? $_POST['sendmessage'] : '' );
	$init = sanitize( isset( $_POST['init'] ) ? ( $_POST['init'] == '1' ? true : false ) : '' );

	header( 'Content-Type: text/javascript; charset=UTF-8' );

	if( $sendMessage == '' )
		return;

	$serial = new phpSerial;
	$serial->deviceSet( "/dev/ttyS0" );
	$serial->confBaudRate( 19200 );
	$serial->confParity( 'none' );
	$serial->confCharacterLength( 8 );
	$serial->confStopBits( 1 );
	$serial->confFlowControl( 'none' );
	$serial->deviceOpen();

	$serial->sendMessage("$sendMessage\r");
	$buf = $serial->readPort(1024);
	$read = '';
	while( $buf != ' ' . chr(8) )
	{
		$read .= $buf;
		$serial->sendMessage( ' ' . chr(8) );
		$buf = $serial->readPort(1024);
	}
	$read = str_replace( ' ' . chr(8), '', $read );
	echo '$("status-log").value += "\n' . str_replace( array( "\n", '"', "\r" ), array( '<br>', '&quot;', '' ), $read ) . '";';
	echo '$("status-log").value = $("status-log").value.replace(/<br>/g,"\n");';
	echo '$("status-log").scrollTop = $("status-log").scrollHeight;';

	$lines = explode( "\r", $read );
	if( $lines )
	{
		foreach( $lines as $line )
		{
			$words = explode( ' ', $line );
			if( count( $words ) > 1 )
			{
				switch( trim($words[0]) )
				{
				case 'STS':
					echo '$("status-status").innerHTML = "' . $words[1] . '";';
					if( $words[1] == 'idle' )
					{
						echo 'clearInterval( refreshInterval );	refreshTimerRunning = 0;';
						echo '$("status-est").hide();';
					}
					else
						echo 'if( !refreshTimerRunning ) { refreshTimerRunning = 1; refreshInterval = setInterval( "refresh();", 500 ); }';
					break;
				case 'POS':
					echo '$("status-currpos-value").innerHTML = "' . $words[1] . '";';
					echo '$("status-currdeg-value").innerHTML = calcDegreesFromPos( $("status-currpos-value").innerHTML );';
					echo 'reposCurrPosMarker( parseInt( $("status-currdeg-value").innerHTML ) );';
					if( $init )
						echo 'destMarker.setPosition( currPosMarker.getPosition() );';
					break;
				case 'DST':
					if( $words[1] == 'no' )
						$words[1] = 'N/A';
					echo '$("status-destpos-value").innerHTML = "' . $words[1] . '";';
					break;
				case 'EST':
					echo '$("status-est").show();';
					echo '$("status-est-value").innerHTML = "' . trim($words[1]) . '";';
					break;
				case 'EPL':
					$bankno = trim( trim( $words[2] ), '#:' );
					$words[3] = trim( $words[3] );
					$bankName = '';
					if( $words[3] == 'empty' )
						$bankName = "#$bankno - empty";
					else
					{
						for( $i = 4; isset( $words[$i] ); $i++ )
							$bankName .= $words[$i];
					}
					echo '$("memory-button-' . $bankno . '").value = "Goto ' . trim( $bankName ) . '";';
					break;
				}
			}
		}
	}
	
	$serial->deviceClose();
?>
