<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head profile="http://gmpg.org/xfn/11">

	<title>rotator</title>

	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<meta name="description" content="antenna rotator">
	<meta name="keywords" content="antenna, rotator, ham, amateur, radio">
	<meta name="author" content="http://www.nonoo.hu/">

	<link rel="shortcut icon" type="image/x-icon" href="favicon.ico" /> 

	<meta name="viewport" content="initial-scale=1.0, user-scalable=no" />
	<script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=false"></script>

	<script type="text/javascript" src="prototype.js"></script>
	<script type="text/javascript" src="helper.js"></script>
	<script type="text/javascript" src="rotator.js"></script>

</head>

<body onload="javascript:init();">

	<div id="map_canvas" style="width: 800px; height: 500px; float: left;"></div>
	<div id="status" style="float: left; margin-left: 20px; width: 370px; height: 80px;">
		<div id="status-status">N/A</div>
		<div id="status-currpos">Currpos: <span id="status-currpos-value">N/A</span> Currdeg: <span id="status-currdeg-value">N/A</span>°</div>
		<div id="status-destpos">Destpos: <span id="status-destpos-value">N/A</span> Destdeg: <span id="status-destdeg-value">N/A</span>° DestDistance: <span id="status-destdistance-value">N/A</span> km</div>
		<div id="status-est" style="display: none;">ETA: <span id="status-est-value">N/A</span> sec.</div>
	</div>
	<div id="controls" style="float: left; margin-left: 20px;">
		<input type="button" value="Stop rotating" onclick="javascript:sendMessage('r0');" />
		<input type="button" value="Status" onclick="javascript:sendMessage('s');" /><br/>
		<input type="button" value="Rotate CW" onclick="javascript:sendMessage('r1');" />
		<input type="button" value="Rotate CCW" onclick="javascript:sendMessage('r2');" /><br/>
		<input type="checkbox" id="controls-autorotate" onclick="javascript:autoRotateCheck();" checked /> autorotate
	</div>
	<div id="log" style="float:left; margin-left: 20px; margin-top: 20px;">
		<textarea id="status-log" style="overflow: auto; width: 600px; height: 370px; display: block;"></textarea>
		<input type="text" id="status-input" value="" style="width: 600px;" onkeydown="javascript:if( event.keyCode == 13 ) { sendMessage(this.value); this.value = ''; }" />
	</div>
	<div style="clear: both;"></div>

	<div id="memory-1" style="float: left; margin-top: 20px;">
		<table>
			<tr>
				<td><input id="memory-button-00" type="button" value="Goto #00" onclick="javascript:gotoBank('00');" /></td>
				<td><input type="button" value="Erase" onclick="javascript:eraseBank(0);" /></td>
			</tr>
			<tr>
				<td><input id="memory-button-01" type="button" value="Goto #01" onclick="javascript:gotoBank('01');" /></td>
				<td><input type="button" value="Erase" onclick="javascript:eraseBank(1);" /></td>
			</tr>
			<tr>
				<td><input id="memory-button-02" type="button" value="Goto #02" onclick="javascript:gotoBank('02');" /></td>
				<td><input type="button" value="Erase" onclick="javascript:eraseBank(2);" /></td>
			</tr>
			<tr>
				<td><input id="memory-button-03" type="button" value="Goto #03" onclick="javascript:gotoBank('03');" /></td>
				<td><input type="button" value="Erase" onclick="javascript:eraseBank(3);" /></td>
			</tr>
			<tr>
				<td><input id="memory-button-04" type="button" value="Goto #04" onclick="javascript:gotoBank('04');" /></td>
				<td><input type="button" value="Erase" onclick="javascript:eraseBank(4);" /></td>
			</tr>
			<tr>
				<td><input id="memory-button-05" type="button" value="Goto #05" onclick="javascript:gotoBank('05');" /></td>
				<td><input type="button" value="Erase" onclick="javascript:eraseBank(5);" /></td>
			</tr>
			<tr>
				<td><input id="memory-button-06" type="button" value="Goto #06" onclick="javascript:gotoBank('06');" /></td>
				<td><input type="button" value="Erase" onclick="javascript:eraseBank(6);" /></td>
			</tr>
			<tr>
				<td><input id="memory-button-07" type="button" value="Goto #07" onclick="javascript:gotoBank('07');" /></td>
				<td><input type="button" value="Erase" onclick="javascript:eraseBank(7);" /></td>
			</tr>
		</table>
	</div>
	<div id="memory-2" style="float: left; margin-left: 20px; margin-top: 20px;">
		<table>
			<tr>
				<td><input id="memory-button-08" type="button" value="Goto #08" onclick="javascript:gotoBank('08');" /></td>
				<td><input type="button" value="Erase" onclick="javascript:eraseBank(8);" /></td>
			</tr>
			<tr>
				<td><input id="memory-button-09" type="button" value="Goto #09" onclick="javascript:gotoBank('09');" /></td>
				<td><input type="button" value="Erase" onclick="javascript:eraseBank(9);" /></td>
			</tr>
			<tr>
				<td><input id="memory-button-10" type="button" value="Goto #10" onclick="javascript:gotoBank(10);" /></td>
				<td><input type="button" value="Erase" onclick="javascript:eraseBank(10);" /></td>
			</tr>
			<tr>
				<td><input id="memory-button-11" type="button" value="Goto #11" onclick="javascript:gotoBank(11);" /></td>
				<td><input type="button" value="Erase" onclick="javascript:eraseBank(11);" /></td>
			</tr>
			<tr>
				<td><input id="memory-button-12" type="button" value="Goto #12" onclick="javascript:gotoBank(12);" /></td>
				<td><input type="button" value="Erase" onclick="javascript:eraseBank(12);" /></td>
			</tr>
			<tr>
				<td><input id="memory-button-13" type="button" value="Goto #13" onclick="javascript:gotoBank(13);" /></td>
				<td><input type="button" value="Erase" onclick="javascript:eraseBank(13);" /></td>
			</tr>
			<tr>
				<td><input id="memory-button-14" type="button" value="Goto #14" onclick="javascript:gotoBank(14);" /></td>
				<td><input type="button" value="Erase" onclick="javascript:eraseBank(14);" /></td>
			</tr>
			<tr>
				<td><input id="memory-button-15" type="button" value="Goto #15" onclick="javascript:gotoBank(15);" /></td>
				<td><input type="button" value="Erase" onclick="javascript:eraseBank(15);" /></td>
			</tr>
		</table>
	</div>
	<div id="memory-3" style="float: left; margin-left: 20px; margin-top: 20px;">
		<table>
			<tr>
				<td><input id="memory-write" type="button" value="Write current pos to EEPROM" onclick="javascript:writeBank();" /></td>
			</tr>
		</table>
	</div>
	<div style="clear: both;"></div>

	<div id="error-message" style="border: 1px red solid; color: red; font-weight: bold; padding: 5px; margin-top: 20px; display: none;"></div>

</body>

</html>
